package com.ruoyi.system.mapper;

import java.util.Date;
import java.util.List;
import com.ruoyi.system.domain.SysUserNotification;
import com.ruoyi.system.domain.dto.SysNotificationDto;
import com.ruoyi.system.domain.dto.WorkLikeDto;
import org.apache.ibatis.annotations.Param;

/**
 * 用户消息通知Mapper接口
 * 
 * @author haotian
 * @date 2024-12-02
 */
public interface SysUserNotificationMapper 
{
    /**
     * 查询用户消息通知
     * 
     * @param id 用户消息通知主键
     * @return 用户消息通知
     */
    public SysUserNotification selectSysUserNotificationById(Long id);

    /**
     * 查询用户消息通知列表
     * 
     * @param sysUserNotification 用户消息通知
     * @return 用户消息通知集合
     */
    public List<SysUserNotification> selectSysUserNotificationList(SysUserNotification sysUserNotification);

    /**
     * 新增用户消息通知
     * 
     * @param sysUserNotification 用户消息通知
     * @return 结果
     */
    public int insertSysUserNotification(SysUserNotification sysUserNotification);

    /**
     * 修改用户消息通知
     * 
     * @param sysUserNotification 用户消息通知
     * @return 结果
     */
    public int updateSysUserNotification(SysUserNotification sysUserNotification);

    /**
     * 删除用户消息通知
     * 
     * @param id 用户消息通知主键
     * @return 结果
     */
    public int deleteSysUserNotificationById(Long id);

    /**
     * 批量删除用户消息通知
     * 
     * @param ids 需要删除的数据主键集合
     * @return 结果
     */
    public int deleteSysUserNotificationByIds(Long[] ids);

    public List<SysUserNotification> unreadNotifiaction(Long userId);

    /*
     * 查看新增关注数
     * */
    public Long getAddFollowerCount(Long userId);

    /*
     * 查看新增点赞数
     * */
    public Long getAddLikeCount(Long userId);

    /*
     * 读消息
     * */
    public Long readNotifiaction(@Param("userId") Long userId, @Param("type") String type, @Param("status") String status, @Param("updateTime") Date updateDate);

    /*
     * 消息--查看系统消息
     * */
    public List<SysNotificationDto> getSystemMessage(Long userId);

    /*

    *消息--查看新增点赞消息
     */
    public List<WorkLikeDto> getWorkLikeList(Long userId);

    /*
     * 注销账户是 删除通知数据
     * */
    public int deleteSysUserNotificationBySenderId(Long userId);


    /**
     * 取消关注时删除关注通知
     *
     */
    public int deleteSysUserNotificationBySenderIdAndUserId(@Param("userId") Long userId, @Param("followedUserId") Long followedUserId, @Param("type") String type);
}
